"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var workbook_1 = require("./ooxml/workbook");
var kendo_file_saver_1 = require("@progress/kendo-file-saver");
var kendo_vue_common_1 = require("@progress/kendo-vue-common");
var package_metadata_1 = require("./package-metadata");
/**
 * @hidden
 */
function saveExcel(exportOptions) {
    (0, kendo_vue_common_1.validatePackage)(package_metadata_1.packageMetadata);
    var saveFn = function (dataURL) {
        if (exportOptions.onExportComplete) {
            exportOptions.onExportComplete.call(undefined, {
                dataURL: dataURL,
                options: exportOptions
            });
        }
        (0, kendo_file_saver_1.saveAs)(dataURL, exportOptions.fileName, {
            forceProxy: exportOptions.forceProxy,
            proxyURL: exportOptions.proxyURL
        });
    };
    var options = (0, workbook_1.workbookOptions)(exportOptions);
    (0, workbook_1.toDataURL)(options).then(saveFn);
}
exports.default = saveExcel;
